package com.zandor300.unhasher;

import java.security.NoSuchAlgorithmException;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.Map;

/**
 * @author Zandor Smith
 * @since 1.0.0
 */
public class Unhasher {

	static char[] letters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!@#$€%^&*()|}{:\"'/.,?><[]\\ -_=+".toCharArray();
	private static String hash;
	private static String result = null;
	private static float seconds = 0;

	static void getChars(char[] lastChars, int pos, int length) throws InterruptedException, ParseException, NoSuchAlgorithmException {
		String newString = "";
		for (char c : letters) {
			if(result != null)
				break;
			char[] newChars = lastChars.clone();
			newChars[pos] = c;
			newString = new String(newChars);
			if (pos + 1 < length) {
				getChars(newChars, pos + 1, length);
			}
			if(Hasher.sha1(newString).equals(hash)) {
				result = newString;
			}
		}
	}

	public static void main(String[] args) throws InterruptedException, ParseException, NoSuchAlgorithmException {
		String[] hashes = args;
		if(hashes.length == 0)
			hashes[0] = Hasher.sha1("aaaa");

		for(String s : hashes) {
			hash = s;

			Timestamp startTime = new Timestamp(System.currentTimeMillis());

			System.out.println("Started hash: " + hash);
			System.out.println();

			print("Started bruteforching...");

			int maxLength = 20;

			for (int length = 1; length <= maxLength; length++) {
				print("Currently searching for passwords with " + length + " characters.");
				for (char c : letters) {
					if (length > 1) {
						char[] chars = new char[length];
						chars[0] = c;
						getChars(chars, 1, length);
						if (result != null)
							break;
					} else {
						String newString = new String(new char[]{c});
						if (Hasher.sha1(newString).equals(hash)) {
							result = newString;
							break;
						}
					}
				}
				if (result != null)
					break;
			}

			Timestamp endTime = new Timestamp(System.currentTimeMillis());

			System.out.println();
			System.out.println("Done!");
			System.out.println();
			System.out.println("Finished hash: " + Hasher.sha1(result));
			System.out.println("Took " + (getDifference(startTime, endTime) / 1000) + " seconds. (End time: " + new SimpleDateFormat("dd-MM-yyyy HH:mm:ss").parse(endTime.toString()) + ")");
			System.out.println("Found string: " + result);
			System.out.println();
		}
	}

	public static void print(String message) throws ParseException {
		SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss");
		System.out.println("[" + sdf.parse(new Timestamp(System.currentTimeMillis()).toString()) + "] " + message);
	}

	public static double getSeconds() {
		return (double) Math.round(seconds * 100) / 100;
	}

	private static double getDifference(Timestamp start, Timestamp end) {
		return end.getTime() - start.getTime();
	}
}
